Compiling Ekiga

From Ekiga
(Difference between revisions)
Jump to: navigation, search
(image:Sources.png Compiling instructions: Document spaces compiling problem)
(Opal: Add pkg-config info)
Line 62: Line 62:
 
  make
 
  make
 
  make install
 
  make install
 +
 +
'''Note''': on some systems, such as Mandriva [http://wiki.mandriva.com/en/Docs/Basic_tasks/Installing_and_removing_software/Installing_from_source#pkgconfig_problems], you can receive an error about not finding ptlib during <code>configure</code> execution.  In that case you might precede configure command with pkgconfig information, like this:
 +
PKG_CONFIG_PATH=/usr/local/lib/pkgconfig ./configure --prefix=/usr
  
 
=== Ekiga ===
 
=== Ekiga ===

Revision as of 13:33, 20 July 2011

Steps: Download sourcesCompile → Execute and Debug

You need to compile, in order, ptlib, opal, and ekiga.

Gnome-status.png This page contains generic instructions. There are a few pages for particular architectures, but which might be slightly outdated:

Gnome-status.png Windows compilation is different, see Building Ekiga for Windows.

Contents

Dependencies

All the dependencies are tracked by configure, as usually.

Not included specially, the usual tools, like a working C/C++ compiling environment and so...

PTLib

Mandatory and optional dependencies: autotools-dev, doxygen, pkg-config, bison, flex, libssl-dev, libldap2-dev, libsasl2-dev, libkrb5-dev, libexpat1-dev, libsdl1.2-dev, libdv4-dev, libv4l-dev, libasound2-dev.

Information about some flags:

  • libexpat1-dev: needed for presence indication.
  • libasound2-dev: optional, if you wish to have ALSA support.

Opal

Mandatory and optional dependencies: doxygen, autotools-dev, pkg-config, libpt-dev, libcelt-dev, libtheora-dev, libgsm1-dev, libspeex-dev, libspeexdsp-dev, libcapi20-dev.

For non-free codecs, see below their dependencies.

Ekiga

Mandatory and optional dependencies: libsasl2-dev, gettext, libldap2-dev, libpt-dev, libopal-dev, libgconf2-dev, libxv-dev, autotools-dev, gnome-pkg-tools, rarian-compat, intltool, libxml-parser-perl, evolution-data-server-dev, gnome-doc-utils, libavahi-client-dev, libavahi-glib-dev, libgtk2.0-dev, libdbus-glib-1-dev, gnome-common, libnotify-dev, libebook1.2-dev, libxext-dev.

For stable ekiga (3.2.x) you need libsigc++-2.0-dev also. For unstable ekiga (>= 3.3.x) you need boost base and signals also.

If you use git repository, you need autotools (automake, autoconf) too.

Information about some flags:

  • gnome-common: to support GNU autotools with some scripts
  • libsdl: for full screen support
  • libebook: for Evolution mail client integration
  • dbus-glib: for basic control of Ekiga using dbus

Sources.png Compiling instructions

Gnome-status.png Note: make sure you do not have ptlib, opal and ekiga installed on your computer before compiling them, see #Uninstall Ekiga for more information.

The compilation is mostly plug'n'play, using the common triple of configure && make && make install (make install as root, if necessary). As usually, you need to install all headers of libraries you want to use a certain feature (e.g. OpenLDAP or ALSA), because otherwise ptlib/opal/ekiga will spit out a message ("checking for ...: no") and silently disable support for that feature.

I assume that common options, like --prefix are known and used.

PTLib

Note that v4l is disabled by default; if you need it, add --enable-v4l to ./configure.

Notes: The path to the directory where ptlib and opal are installed must not contain spaces; also, you need to build ptlib and opal from their directory, as shown below.

Example:

./configure --prefix=/usr 
make
make install

Opal

Example:

./configure --prefix=/usr
make
make install

Note: on some systems, such as Mandriva [1], you can receive an error about not finding ptlib during configure execution. In that case you might precede configure command with pkgconfig information, like this:

PKG_CONFIG_PATH=/usr/local/lib/pkgconfig ./configure --prefix=/usr

Ekiga

If you have downloaded Ekiga from git repository, then you don't have a configure script. You should use ./autogen.sh instead of ./configure below (giving the same parameters).

The following options (among others) are recognized:

  • --disable-gdu disables the generation of the help documentation files (readable with GNOME yelp).
  • --disable-gconf disables GCONF support
    • it's experimental and was introduced to make the WIN32-port possible
    • it saves it config AND addressbooks into a FILE (usually ~/.config/ekiga.conf or whatever was reported by GLib)
    • for the moment, expect some weirdness with the UI and some config keys
  • --disable-avahi disables the generation of zeroconf Avahi code ("Contacts near me")
  • --disable-dbus disables generation of Ekiga's DBUS interface (yes, Ekiga can be remote-controlled a bit)

Example:

./configure --prefix=/usr
make
make install


Additional dependencies of specific video codecs

If you want to use also the non-free codecs in Ekiga, this section presents how to build them.

FFMPEG (SVN)

FFMPEG (SVN) is required for the following video codecs:

In order to install the latest version of FFMPEG, check out the SVN repository

svn co svn://svn.mplayerhq.hu/ffmpeg/trunk ffmpeg

afterwards:

./configure --enable-shared
make
sudo make install

x264 (GIT)

x264 (GIT) is required for the following video codecs:

In order to install the latest version of x264 check out the GIT repository

git clone git://git.videolan.org/x264.git

afterwards:

./configure --enable-shared
make
sudo make install

H.264, MPEG4 Part 2 and H.263+ / H.263-1998 using debian prebuild binaries (maybe working for UBUNTU, too)

  • Don't install self build ffmpeg stuff or move it out of the way (to home or /usr/local/src, make uninstall to be sure)
  • Add a debian 'unofficial' multimedia repository mirror (for Your country or near to) to /etc/apt/sources.list:
deb http://www.debian-multimedia.org testing main
#deb http://debian.netcologne.de/debian-multimedia.org unstable main
#deb http://debian.netcologne.de/debian-multimedia.org experimental main
  • Do 'aptitude update'
  • Install the following packages with aptitude (check apt-cache policy <packagename> for interferences):
 libavcodeccvs51     library to encode decode multimedia streams - runtime
 libavcodeccvs51-dev
 libavformatcvs51   ffmpeg file format library
 libavformatcvs51-dev
 libavutilcvs49         avutil shared libraries
 libavutilcvs49-dev 
 
 or ffmpeg + the above -dev packages only (full auto dependencies handling for runtime libs is done by aptitude) 
  • Install latest Ekiga, Opal, PTlib SVN head snapshots (source links above) configured as usual.
  • Look in the installation and check if codecs are there:
ls -l <opal-configure-prefix>/lib/opal*/codecs/video
-rwxr-xr-x 1 root root 449803 2007-08-09 22:14 h261-vic_video_pwplugin.so
-rwxr-xr-x 1 root root 278056 2007-08-09 22:14 h263-1998_video_pwplugin.so
-rwxr-xr-x 1 root root 133089 2007-06-17 16:27 h263-ffmpeg_video_pwplugin.so
-rwxr-xr-x 1 root root 190334 2007-08-09 22:14 h264_video_pwplugin_helper
-rwxr-xr-x 1 root root 303613 2007-08-09 22:14 h264_video_pwplugin.so
-rwxr-xr-x 1 root root 190008 2007-08-09 22:14 theora_video_pwplugin.so

Uninstall Ekiga

If you want do compile and install (new versions of) ekiga, you should make sure before that you do not have them already installed.

Check if you have previously installed Pwlib, Opal, and Ekiga

Some versions of Linux (like Ubuntu) install Ekiga automatically with Gnome Desktop as it is part of it. If you or your distro have installed Ekiga before, you most likely already have a version of Pwlib & Opal installed. You must check to see what versions you have before downloading other versions. Unless you remove older versions before you start, there is a chance you'll create multiples versions of these libraries on your system, which will stop you from compiling Ekiga.

You can check your version of Ekiga from Ekiga's Help → About menu, or open a Terminal and at the prompt, type:

$ ekiga --version

This will show you the version of Ekiga if any properly installed on your system.

You may want to have a closer look to be sure there is no pwlib (pwlib has been renamed to ptlib) and opal in your system as those libraries can be used by other programs than Ekiga:

Type:

$ whereis pwlib
$ whereis ptlib
$ whereis opal
$ whereis ekiga
Gnome-status.png Alternatively, you can use find to get a list of a program's locations, searching in /usr is usualy a good start:
$ find /usr -name '*pwlib*'
$ find /usr -name '*libpt*'
$ find /usr -name '*opal*'
$ find /usr -name '*ekiga*'

This will show you if Pwlib, Opal, & Ekiga has been installed.

Uninstall previously installed pwlib, opal, and Ekiga

First, you should try your package manager which is distro dependant: Debian and Ubuntu use synaptic and apt,... and search for "pwlib" "libpt" "opal" "ekiga" in it. Then uninstall all libpt/pwlib/opal/ekiga packages (pwlib sometimes comes with plugins in separate packages and pwlib may be renamed "libpt", uninstall them all).

FIXME: list of package managers per distro

If Ekiga was installed from sources, it is recommended you uninstall them by:

$ cd to appropriate directory (where you compiled Ekiga, then Opal and finaly pwlib)

and as root for each source:

# make uninstall
Gnome-status.png Tip for Ubuntu users:
$ sudo make uninstall
Personal tools